const PATFINDER_PATCH = 160812
dim shared as uinteger PATFINDERVERSION = 2*&h10000000 + 0*&h100000 + PATFINDER_PATCH
dim shared as integer BGC = &h000000, FGC = &hffffff, HGRAU = &hbbbbbb, DGRAU = &h555555, CROT = &hff1111, MBC = &h222222

chdir exepath

#include once "include/xmlparse.bas"
#include once "include/http.bas"
#if defined(__FB_UNIX__)
  const root = "./", slash = "/"
#elseif defined(__FB_PCOS__)
  const root = "", slash = "\"
#else
  #error "Fehler: Unbekanntes Betriebssystem!"
#endif
#include once "patinc.bi"

type TypPatience
  as string url, name, sortname, fenstername, anleitung, regel(1 to 9), regelID(1 to 9)
  as integer patversion, programmversion, levelmax, inaktiv, gewonnen(1 to 9), verloren(1 to 9), punktemax
  as integer punkte(1 to 9, 24), punktsumme(1 to 9), zeitgewinnmin(1 to 9), zeitgewinnmax(1 to 9)
  as integer zeitgewinnsumme(1 to 9), zeitverliermin(1 to 9), zeitverliermax(1 to 9), zeitverliersumme(1 to 9)
  as integer level(1 to 9), regelanz, regelaktiv, schnitt
end type
type TypFeld
  as ubyte kuerzel, verdeckt, karten, richtung
  as integer x, y, eng, karte(0 to 207), kartenmax, spezial, sichtbar
  as string id, typ
end type
type TypSpiel
  as integer maxX, maxY, kartenset, karten, felder
  as TypFeld feld(1 to 220)
end type

declare sub auswahlbildschirm(patliste() as TypPatience, pstart as integer)
declare function auswahl(patliste() as TypPatience, byref pstart as integer) as integer
declare sub credits
declare function datenLesen(xml as TypXml) as TypPatience
declare function eingabe(x as integer, y as integer, typ as integer = 0) as string
declare function einstellungen as integer
declare function info(pat as TypPatience) as integer
declare sub infoStatistik(pat as TypPatience, punkteschnitt as string)
declare sub quicksort overload (a() as string, byval s as integer = 0, byval e as integer = &hffff)
declare sub quicksort(array() as TypPatience, byval start as integer = 0, byval ende as integer = &hffff)
declare function sortname(text as string) as string
declare sub spielParse(pat as TypPatience, spiel as TypSpiel, xmlrest as string, vorlage() as TypFeld, anzVorlagen as integer)
declare sub spielStarten(pat as TypPatience)
declare sub statistikEinlesen(benutzer as string, byref pat as TypPatience)
declare function sucheBild(bilderliste() as string, altesBild as integer, groesse as integer) as integer
declare sub tischZeichnen(tisch as integer, vorn as any ptr, hinten as any ptr, hinten2 as any ptr, _
                          breite as integer, ruecken as integer)

dim as TypPatience allepat(), aktuellpat(), onlinepat()
dim as string pat, xmltemp, taste, exec_return
dim shared as string datapfad, benutzer, tempstring
dim shared as integer PATWORKVERSION, onlinePatfinder, onlinePatwork, allezahl = 0, aktuellzahl = 0, onlinezahl, menu = 1
dim shared as TypButton spieler, mpunkt(1 to 3), apunkt(), hpunkt(), regelwahl, regeltext, soundEinAus, animation
dim shared as TypButton weiter, zurueck, einstellung, danksagung, ende, tischfarbe, infosOk, helpSpielen, helpEnde
dim shared as TypButton setMinus, setPlus, setText, groesseMinus, groessePlus, groesseText
dim shared as TypButton rueckenMinus, rueckenPlus, rueckenText, rueckenVar
dim as integer pstart, f = freefile, spielergebnis, punkte, nr, mx, my, mb, tempint
dim as TypXML xml
dim shared as string SpielerSet, SpielerRuecken
dim shared as integer SpielerSound, SpielerAnimation, SpielerTischfarbe, SpielerRueckenVar
benutzer = ""
SpielerSet = "40standard"
SpielerSound = -1
SpielerTischfarbe = &hffdd55
spieler = type<TypButton>(10, 20, 220, 25, BRand, "Spieler: " & benutzer)
mpunkt(1) = type<TypButton>(280, 20, 90, 25, BRand, "spielen")
mpunkt(2) = type<TypButton>(380, 20, 90, 25, BRand, "updaten")
mpunkt(3) = type<typButton>(480, 20, 90, 25, BRand, "aktivieren")
einstellung = type<TypButton>(405, 550, 120, 25, BRand, "Einstellungen")
danksagung = type<TypButton>(275, 550, 120, 25, BRand, "Danksagungen")
ende = type<TypButton>(670, 550, 120, 25, BRand, "Ende")
weiter = type<TypButton>(10, 550, 70, 25, BRand, "weiter")
zurueck = type<TypButton>(90, 550, 70, 25, BRand, !"zur\129ck")
helpSpielen = type<TypButton>(570, 550, 100, 25, BRand, !"starten")
helpEnde = type<TypButton>(690, 550, 100, 25, BRand, !"zur\129ck")
setMinus = type<TypButton>(50, 130, 20, 20, BRand, "<")
setPlus = type<TypButton>(250, 130, 20, 20, BRand, ">")
setText = type<TypButton>(70, 130, 170, 0, 0, "")
groesseMinus = type<TypButton>(50, 160, 20, 20, BRand, "<")
groessePlus = type<TypButton>(250, 160, 20, 20, BRand, ">")
groesseText = type<TypButton>(70, 160, 170, 0, 0, "")
rueckenMinus = type<TypButton>(50, 190, 20, 20, BRand, "<")
rueckenPlus = type<TypButton>(250, 190, 20, 20, BRand, ">")
rueckenText = type<TypButton>(70, 190, 170, 0, 0, "")
rueckenVar = type<TypButton>(50, 230, 220, 20, BRand, "")
soundEinAus = type<TypButton>(220, 300, 50, 20, BRand, "")
animation = type<TypButton>(220, 340, 50, 20, BRand, "")
tischfarbe = type<TypButton>(50, 400, 220, 22, BRand, "")
infosOk = type<TypButton>(360, 500, 80, 30, BRand, "OK")

chdir exepath
open "datenpfad" for input as #f
line input #f, datapfad
close #f
if open(datapfad & "benutzer" & slash & "aktuellerBenutzer" for input as #f) = 0 then
  line input #f, benutzer
  close #f
end if
' Programmversion von patwork ermitteln
open pipe root & "patwork -v" for input as #f
input #f, PATWORKVERSION
close #f
screenres 800, 600, 32, 2
screenset 0, 0
color FGC, BGC
windowtitle "Patfinder - Patiencen-Manager"
width 100, 37

' ersten Benutzer anlegen
if benutzer = "" then
  print
  print " Dies scheint der erste Aufruf des Programmes zu sein. Bevor Sie fortfahren koennen, muessen Sie"
  print " zuerst einen Benutzernamen eingeben. Statistiken werden getrennt von den Benutzern gespeichert."
  print
  print " Geben Sie einen Benutzernamen ein (nur Buchstaben, Ziffern und Unterstrich, max. 16 Zeichen)."
  print " Bestaetigen Sie Ihre Eingabe mit RETURN."
  do
    benutzer = eingabe(8, 108)
  loop until benutzer <> ""
  if dir(datapfad & "benutzer" & slash & benutzer, 16) = "" then
    mkdir datapfad & "benutzer" & slash & benutzer
    open datapfad & "benutzer" & slash & benutzer & slash & "inaktiv" for output as #f
    close #f
  end if
  open datapfad & "benutzer" & slash & "aktuellerBenutzer" for output as #f
  print #f, benutzer
  close #f
  cls
end if
spieler.text = "Spieler: " & benutzer

' Warte-Bildschirm
cls
locate 17, 38
print "Daten werden gelesen ..."
' verfuegbare Patiencen einlesen
pat = dir(datapfad & "spiele" & slash & "*.xml")
do while pat <> ""
  open datapfad & "spiele" & slash & pat for input as #f
  xml = xmlParse(, 1)
  close #f
  if xml.tag = "spiel" then
    redim preserve allepat(allezahl)
    allepat(allezahl) = datenLesen(xml)
    allepat(allezahl).url = left(pat, len(pat)-4)
    statistikEinlesen(benutzer, allepat(allezahl))
    allezahl += 1
  end if
  pat = dir
loop
quicksort allepat()
open datapfad & "benutzer" & slash & benutzer & slash & "inaktiv" for input as #f
do while not eof(f)
  line input #f, tempstring
  for i as integer = 0 to allezahl - 1
    if tempstring = allepat(i).url then allepat(i).inaktiv = -1 : exit for
  next
loop
close #f
' Punkteschnitte einlesen
if open(datapfad & "spiele" & slash & "schnitt" for input as #f) = 0 then
  dim as string dateiname
  do until eof(f)
    line input #f, tempstring
    dateiname = mid(tempstring, instr(tempstring, chr(9))+1)
    for i as integer = 0 to allezahl - 1
      if allepat(i).url = dateiname then allepat(i).schnitt = val(tempstring) : exit for
    next
  loop
  close #f
end if
' aktivierte Patiencen zusammenstellen
for i as integer = 0 to allezahl - 1
  if allepat(i).inaktiv = 0 then
    redim preserve aktuellpat(aktuellzahl)
    aktuellpat(aktuellzahl) = allepat(i)
    aktuellzahl += 1
  end if
next
pstart = 0

' Auswahl
do
  do
    getmouse mx, my,, mb
    sleep 1
  loop until mb < 1
  select case menu
    case 1 : nr = auswahl(aktuellpat(), pstart)
    case 2 : nr = auswahl(onlinepat(), pstart)
    case 3 : nr = auswahl(allepat(), pstart)
  end select
  select case nr
    case -1
      ' Spielernamen eingeben
      line (12, 22)-step(216, 21), BGC, bf
      draw string (20, 25), "Spieler:"
      dim as string benutzerNeu = eingabe(92, 25)
      if benutzerNeu <> "" and benutzerNeu <> benutzer then
        ' inaktive Spiele sichern
        open datapfad & "benutzer" & slash & benutzer & slash & "inaktiv" for output as #f
        for i as integer = 0 to allezahl - 1
          if allepat(i).inaktiv = -1 then print #f, allepat(i).url
        next
        close #f
        benutzer = benutzerNeu
      end if
      if dir(datapfad & "benutzer" & slash & benutzer, 16) = "" then
        mkdir datapfad & "benutzer" & slash & benutzer
        open datapfad & "benutzer" & slash & benutzer & slash & "inaktiv" for output as #f
        close #f
      end if
      open datapfad & "benutzer" & slash & "aktuellerBenutzer" for output as #f
      print #f, benutzer
      close #f
      for i as integer = 0 to allezahl-1
        statistikEinlesen benutzer, allepat(i)
      next
      spieler.text = "Spieler: " & benutzer
      spieler.zeichnen
      ' inaktive Spiele einlesen
      for i as integer = 0 to allezahl - 1
        allepat(i).inaktiv = 0
      next
      open datapfad & "benutzer" & slash & benutzer & slash & "inaktiv" for input as #f
      do while not eof(f)
        line input #f, tempstring
        for i as integer = 0 to allezahl - 1
          if tempstring = allepat(i).url then allepat(i).inaktiv = -1 : exit for
        next
      loop
      close #f
      aktuellzahl = 0
      for i as integer = 0 to allezahl - 1
        if allepat(i).inaktiv = 0 then
          redim preserve aktuellpat(aktuellzahl)
          aktuellpat(aktuellzahl) = allepat(i)
          aktuellzahl += 1
        end if
      next
      pstart = 0
    case -2
      ' Menue-Auswahl "spielen"
      pstart = 0
      aktuellzahl = 0
      erase aktuellpat
      for i as integer = 0 to allezahl - 1
        if allepat(i).inaktiv = 0 then
          redim preserve aktuellpat(aktuellzahl)
          aktuellpat(aktuellzahl) = allepat(i)
          aktuellzahl += 1
        end if
      next
    case -3
      ' Menue-Auswahl "updaten"
      pstart = 0
      if onlinePatfinder = 0 then
        if nachricht("Es wird nun versucht, eine Ver-\nbindung über Internet herzustellen.", "Weiter\nAbbruch") = 1 then
          ' Punkteschnitte einlesen
          dim as string http = httpGet("programmierung.eulengesang.de","patfinder/spiele/schnitt"), dateiname
          dim as integer such = instr(http, !"\r\n\r\n"), s1, s2
          open datapfad & "spiele" & slash & "schnitt" for output as #f
          print #f, mid(http, such+4)
          close f
          s1 = such+4
          s2 = instr(s1, http, !"\n")
          do while s2
            tempstring = mid(http, s1, s2-s1)
            dateiname = mid(tempstring, instr(tempstring, chr(9))+1)
            for i as integer = 0 to allezahl - 1
              if allepat(i).url = dateiname then allepat(i).schnitt = val(tempstring) : exit for
            next
            s1 = s2 + 1
            s2 = instr(s1, http, !"\n")
          loop
          dim as string httpinfo = httpGet("programmierung.eulengesang.de","patfinder/version.php")
          such = instr(httpinfo, "VERSION ")
          if such = 0 then exit select
          s1 = instr(such+8, httpinfo, ".")
          s2 = instr(such+10, httpinfo, ".")
          onlinePatfinder = val(mid(httpinfo, such+8, s1-such-8))*&h10000000 + val(mid(httpinfo, s1+1, s2-s1-1))*&h100000 _
                          + val(mid(httpinfo, s2+1, 6))
          such = instr(such+19, httpinfo, "VERSION ")
          s1 = instr(such+8, httpinfo, ".")
          s2 = instr(such+10, httpinfo, ".")
          onlinePatwork   = val(mid(httpinfo, such+8, s1-such-8))*&h10000000 + val(mid(httpinfo, s1+1, s2-s1-1))*&h100000 _
                          + val(mid(httpinfo, s2+1, 6))
          httpinfo = mid(httpinfo, such+23)

          dim i as integer, tempurl as string, aktualisierbar as integer
          do while httpinfo <> ""
            such = instr(httpinfo, "<br>")
            tempurl = mid(httpinfo, 8, such-8)
            aktualisierbar = 0            
            ' auf Aktualisierung pruefen
            for i = 0 to allezahl - 1
              if allepat(i).url = tempurl then
                if val(left(httpinfo, 6)) > allepat(i).patversion then aktualisierbar = -1
                exit for
              end if
            next
            ' Daten einlesen
            if aktualisierbar or i = allezahl then
              redim preserve onlinepat(onlinezahl)
              dim as string http2 = httpGet("programmierung.eulengesang.de","patfinder/spiele/" & tempurl & ".xml")
              dim as integer such2 = instr(http2, "<?xml ")
              onlinepat(onlinezahl) = datenLesen(xmlParse(mid(http2, such2)))
              onlinepat(onlinezahl).url = tempurl
              if aktualisierbar = 0 then onlinepat(onlinezahl).inaktiv = -1
              onlinezahl += 1
            end if
            httpinfo = mid(httpinfo, such+4)
            if such = 0 then exit do
          loop
        end if
      end if
    case -4
      ' Menue-Auswahl "aktivieren"
      pstart = 0
    case -5
      if einstellungen = -27 then nr = -27
    case -6
      credits
    case is >= 0
      if (nr and &h1000000) = 0 then
        ' Spiel aktiviert
        select case menu
          case 1
            spielStarten aktuellPat(nr)
          case 2
            ' Spiel updaten
            if onlinepat(nr).programmversion > (PATWORKVERSION and &hfffff) then
              nachricht "Die Patience erfordert eine neuere\npatwork-Version. Aktualisieren Sie\nzuerst patwork, bevor Sie diese\nPatience herunterladen!", "Ok"
              exit select
            end if
            if nachricht("Wollen Sie die aktuelle Version\ndieser Patience installieren?", "Ja\nNein") = 2 then exit select
            dim as string httpinfo = httpGet("programmierung.eulengesang.de","patfinder/spiele/" & onlinepat(nr).url & ".xml")
            dim as integer such = instr(httpinfo, "<?xml ")
            open datapfad & "spiele/" & onlinepat(nr).url & ".xml" for output as #f
            print #f, mid(httpinfo, such)
            close #f
            ' Spiel in die Gesamtliste schreiben und aus der Onlineliste nehmen
            if onlinepat(nr).inaktiv = -1 then
              ' neu installieren
              redim preserve allepat(allezahl)
              allepat(allezahl) = onlinepat(nr)
              allepat(allezahl).inaktiv = 0
              statistikEinlesen benutzer, allepat(allezahl)
              allezahl += 1
              quicksort allepat()
            else
              ' updaten
              for i as integer = 0 to ubound(allepat)
                if allepat(i).url = onlinepat(nr).url then
                  allepat(i) = onlinepat(nr)
                  allepat(i).inaktiv = 0
                  statistikEinlesen benutzer, allepat(i)
                  exit for
                end if
              next
            end if
            for i as integer = nr to ubound(onlinepat) - 1
              onlinepat(i) = onlinepat(i+1)
            next
            onlinezahl -= 1
            if onlinezahl = 0 then
              erase onlinepat
            else
              redim preserve onlinepat(onlinezahl - 1)
            end if
          case 3
            ' Spiel (de-)aktivieren
            allepat(nr).inaktiv xor= -1
        end select
      else
        ' Informationen zeigen
        select case menu
          case 1 : if info(aktuellpat(nr - &h1000000)) = -27 then exit do
          case 2 : if info(onlinepat (nr - &h1000000)) = -27 then exit do
          case 3 : if info(allepat   (nr - &h1000000)) = -27 then exit do
        end select
      end if
  end select
loop until nr = -27
' inaktive Spiele sichern
open datapfad & "benutzer" & slash & benutzer & slash & "inaktiv" for output as #f
for i as integer = 0 to allezahl - 1
  if allepat(i).inaktiv = -1 then print #f, allepat(i).url
next
close #f

sub auswahlbildschirm(patliste() as TypPatience, pstart as integer)
  dim as integer patzahl = ubound(patliste) + 1, farbe
  if @patliste(ubound(patliste)) = 0 then patzahl = 0
  dim as integer x = 0, y = 0
  if ubound(apunkt) < patzahl - 1 then redim apunkt(patzahl - 1), hpunkt(patzahl - 1)
  screenlock
  cls
  spieler.zeichnen
  einstellung.zeichnen
  danksagung.zeichnen
  ende.zeichnen
  for i as integer = 1 to 3
    mpunkt(i).zeichnen -(menu=i)
  next
  if patzahl = 0 then draw string (190, 200), "Es stehen zur Zeit keine Patiencen auf dieser Liste."
  for i as integer = 0 to patzahl - 1
    if y >= pstart and y < pstart + 15 then
      apunkt(i) = type<TypButton>(x*265+10, (y-pstart)*30+70, 220, 25, BRand, left(patliste(i).name, 25))
      hpunkt(i) = type<TypButton>(x*265+235, (y-pstart)*30+70, 23, 23, BRand, "?")
      if patliste(i).programmversion > (PATWORKVERSION and &hfffff) then
        apunkt(i).zeichnen 3
      else
        apunkt(i).zeichnen -2*patliste(i).inaktiv
      end if
      hpunkt(i).zeichnen -2*patliste(i).inaktiv
    else
      apunkt(i) = type<TypButton>(0, 0, 0, 0, 0, "")
      hpunkt(i) = type<TypButton>(0, 0, 0, 0, 0, "")
    end if
    y += 1
    if y > (patzahl-x-1)\3 then y = 0 : x += 1
  next
  if patzahl > 45 then
    weiter.zeichnen -3*(pstart*3 + 46 > patzahl)
    zurueck.zeichnen -3*(pstart = 0)
  end if
  if menu = 2 and onlinePatfinder > 0 then
    dim as string check
    if onlinePatfinder > PATFINDERVERSION then
      check = "veraltet!"
      farbe = CROT
    else
      check = "aktuell"
      farbe = FGC
    end if
    draw string (620, 15), "patfinder " & check, farbe
    if onlinePatwork > PATWORKVERSION then
      check = "veraltet!"
      farbe = CROT
    else
      check = "aktuell"
      farbe = FGC
    end if
    draw string (620, 35), "patwork   " & check, farbe
  else
    draw string (620, 15), "patfinder v" & (PATFINDERVERSION shr 28) & "." & _
         ((PATFINDERVERSION shr 20) and &hff) & "." & (PATFINDERVERSION and &hfffff)
    draw string (620, 35), "patwork   v" & (PATWORKVERSION shr 28) & "." & _
         ((PATWORKVERSION shr 20) and &hff) & "." & (PATWORKVERSION and &hfffff)
  end if
  screenunlock
end sub

function auswahl(patliste() as TypPatience, byref pstart as integer) as integer
  ' Rueckgabewerte:
  ' 0 <= nr < &h1000000: ausgewählte Patience
  ' nr >= &h1000000:     ausgewählte Information
  ' -1:  Namensfeld
  ' -2:  Spielauswahl
  ' -3:  Update-Suche
  ' -4:  (De-)Aktivierung
  ' -27: Programmende (ESC oder ALT+F4)
  ' -72 / -80: blaettern; muss nicht mehr ausgewertet werden
  dim as integer mx, my, mr, mb, mx2, my2, mralt, x, y, x2, y2, nr, nr2, patzahl = ubound(patliste) + 1
  if @patliste(ubound(patliste)) = 0 then patzahl = 0
  dim as string taste
  auswahlbildschirm patliste(), pstart
  getmouse mx, my, mralt
  do
    getmouse mx, my, mr, mb
    taste = inkey
    sleep 1
    if my >= 0 then
      if mr < mralt then
        taste = chr(255, 80)
      elseif mr > mralt then
        taste = chr(255, 72)
      end if
      mralt = mr
    end if
  loop until mb = 1 or taste = chr(27) or taste = chr(255, 107) or taste = chr(255, 80) or taste = chr(255, 72)
  if taste = chr(27) or taste = chr(255, 107) then return -27
  nr = -15
  if taste <> chr(255, 80) and taste <> chr(255, 72) then
    if spieler.in(mx, my) then spieler.zeichnen 1 : nr = -1
    for i as integer = 1 to 3
      if mpunkt(i).in(mx, my) then mpunkt(i).zeichnen 1 : nr = -1 - i : exit for
    next
    if einstellung.in(mx, my) then einstellung.zeichnen 1 : nr = -5
    if danksagung.in(mx, my) then danksagung.zeichnen 1 : nr = -6
    if ende.in(mx, my) then ende.zeichnen 1 : nr = -27
    for i as integer = 0 to patzahl - 1
      if apunkt(i).in(mx, my) then
        if patliste(i).programmversion > (PATWORKVERSION and &hfffff) then exit for
        apunkt(i).zeichnen 1 : nr = i : exit for
      elseif hpunkt(i).in(mx, my) then
        hpunkt(i).zeichnen 1 : nr = i + &h1000000 : exit for
      end if
    next
  end if
  do
    getmouse mx, my,, mb
    sleep 1
  loop until mb = 0
  ' Vergleiche Mausdruck mit Maus-Loslassen
  nr2 = -15
  if taste = chr(255, 80) orelse weiter.in(mx, my) then
    ' weiterblaettern
    if pstart*3 + 45 < patzahl then
      pstart += 1
      auswahlbildschirm patliste(), pstart
      do
        getmouse mx, my,, mb
        sleep 1
      loop until mb = 0
    end if
    return -80
  elseif taste = chr(255, 72) orelse zurueck.in(mx, my) then
    ' zurueckblaettern
    if pstart > 0 then
      pstart -= 1
      auswahlbildschirm patliste(), pstart
      do
        getmouse mx, my,, mb
        sleep 1
      loop until mb = 0
    end if
    return -72
  end if
  if nr = -1 and spieler.in(mx, my) then return -1
  for i as integer = 1 to 3
    if nr = -1 - i and mpunkt(i).in(mx, my) then menu = i : return -1 - i
  next
  if nr = -5 and einstellung.in(mx, my) then return -5
  if nr = -6 and danksagung.in(mx, my) then return -6
  if nr = -27 and ende.in(mx, my) then return -27
  for i as integer = 0 to patzahl - 1
    if nr = i and apunkt(i).in(mx, my) then
      return nr
    elseif nr = i + &h1000000 and hpunkt(i).in(mx, my) then
      return nr
    end if
  next
  return -15
end function

sub credits
  cls
  draw string (300, 30), "D A N K S A G U N G E N"
  draw string (40, 80), "patfinder und patwork wurden von Stephan Markthaler programmiert."
  draw string (40, 100), "Information und Neuerungen finden Sie unter http://programmierung.eulengesang.de/patfinder"
  draw string (40, 120), "Lob und Kritik bitte an die Kontaktadresse: programmierung@eulengesang.de"
  draw string (40, 200), "Die verwendeten Soundeffekte basieren auf Vorlagen von Freesound (http://freesound.org)"
  draw string (40, 220), "  * legen.ogg: Tick_01 von A43"
  draw string (40, 240), "  * misch.ogg: shuffle von deathpie"
  draw string (40, 260), "Alle Sounds stehen unter der Lizenz Creative Commons Sampling Plus 1.0"
  draw string (40, 280), "Die Lizenzbedingungen finden Sie unter http://creativecommons.org/licenses/sampling+/1.0"
  getkey
end sub

function datenLesen(xml as TypXml) as TypPatience
  dim as string xmltemp = xml.inhalt
  dim as TypPatience ret
  with ret
    .name = xml.GetAttr("name")
    .fenstername = .name
    .sortname = sortname(.name)
    ersetzeUmlaute .name
    ersetzeUmlaute .fenstername, -1
    do while xmltemp <> ""
      select case xml.tag
        case "programm"  : .programmversion = val(xml.inhalt)
        case "version"   : .patversion = val(xml.inhalt)
        case "anleitung" : .anleitung = xml.inhalt : ersetzeUmlaute .anleitung
        case "levelmax"  : .levelmax = val(xml.inhalt)
        case "regelwerk"
          dim as string xmltemp2 = xml.inhalt
          do while xmltemp2 <> ""
            xml = xmlParse(xmltemp2)
            if xml.tag = "regel" then
              .regelanz += 1
              .regel(.regelanz) = xml.inhalt
              .regelID(.regelanz) = xml.GetAttr("id")
            end if
            xmltemp2 = xml.rest
          loop
      end select
      xml = xmlParse(xmltemp)
      xmltemp = xml.rest
    loop
    if .regelanz = 0 then .regelanz = 1
  end with
  return ret
end function

function eingabe(x as integer, y as integer, typ as integer = 0) as string
  dim as string ret = "", taste
  dim as integer laenge = 16
  if typ = 1 then laenge = 6
  do
    line (x, y)-step(laenge*8, 15), BGC, bf
    draw string (x, y), ret
    do
      taste = inkey
      sleep 1
    loop until taste <> ""
    select case taste
      case "a" to "f", "A" to "F", "0" to "9", "_"
        if typ = 1 then taste = ucase(taste)
        if len(ret) < laenge then ret &= taste
      case "g" to "z", "G" to "Z"
        if typ = 0 andalso len(ret) < 16 then ret &= taste
      case chr(8): ret = left(ret, len(ret)-1)
      case chr(27): return ""
      case chr(255, 107): end
    end select
    if typ = 1 andalso len(ret) = 6 then exit do
  loop until taste = chr(13) and typ = 0
  return ret
end function

function einstellungen as integer
  dim as string ordner, kartensets(), ruecken(), taste, temp
  dim as integer anzSets = 0, anzRuecken, setZaehler = -1, rueckenZaehler = -1, mx, my, mb, groesse, f = freefile
  ' Benutzerdaten einlesen
  if dir("benutzer" & slash & benutzer & slash & "einstellung") <> "" then
    open "benutzer" & slash & benutzer & slash & "einstellung" for input as #f
    line input #1, SpielerSet
    line input #1, SpielerRuecken
    if instrrev(SpielerRuecken, " ") = len(SpielerRuecken)-1 then
      SpielerRueckenVar = val(right(SpielerRuecken, 1))
      SpielerRuecken = left(SpielerRuecken, len(SpielerRuecken)-2)
    end if
    line input #1, temp
    SpielerSound = val(temp)
    line input #1, temp
    SpielerAnimation = val(temp)
    line input #1, temp
    SpielerTischfarbe = val(temp)
    close #f
  end if
  ' Kartenbilder einlesen
  ordner = dir("karten" & slash & "*", -1)
  do while ordner <> ""
    if ordner = "ruecken" or ordner = "." or ordner = ".." then ordner = dir : continue do
    redim preserve kartensets(anzSets)
    kartensets(anzSets) = ordner
    groesse = val(left(ordner, 2))
    anzSets += 1
    ordner = dir
  loop
  quicksort kartensets()
  dim as any ptr bild(anzSets-1)
  for i as integer = 0 to anzSets - 1
    groesse = val(left(kartensets(i), 2))
    bild(i) = imagecreate(groesse, (groesse\2)*3)
    bload "karten" & slash & kartensets(i) & slash & "kreuz11.bmp", bild(i)
    if kartensets(i) = SpielerSet then setZaehler = i
    if setZaehler < 0 and kartensets(i) = "40standard" then setZaehler = i
  next
  if anzSets > 0 and setZaehler < 0 then setZaehler = 0
  if anzSets > 0 then groesse = val(left(kartensets(setZaehler), 2))
  ' Rueckenbilder einlesen
  ordner = dir("karten" & slash & "ruecken" & slash & "*.bmp")
  do while ordner <> ""
    if right(ordner, 6) = "_2.bmp" then ordner = dir : continue do
    redim preserve ruecken(anzRuecken)
    ordner = left(ordner, len(ordner)-4)
    ruecken(anzRuecken) = ordner
    anzRuecken += 1
    ordner = dir
  loop
  quicksort ruecken()
  dim as any ptr bildR(anzRuecken-1), bildR2(anzRuecken-1)
  for i as integer = 0 to anzRuecken - 1
    ordner = "karten" & slash & "ruecken" & slash & ruecken(i)
    dim as integer breite = val(left(ruecken(i), 2))
    bildR(i) = imagecreate(breite, (breite\2)*3)
    bload ordner & ".bmp", bildR(i)
    if fileexists(ordner & "_2.bmp") then
      bildR2(i) = imagecreate(breite, (breite\2)*3)
      bload ordner & "_2.bmp", bildR2(i)
    end if
    if ruecken(i) = SpielerRuecken then rueckenZaehler = i
    if rueckenZaehler = 0 and val(left(ruecken(i), 2)) = groesse then rueckenZaehler = i
  next
  if anzSets > 0 then
    if setZaehler < 0 then setZaehler = 0
    setText.text = mid(kartensets(setZaehler), 3)
    groesseText.text = !"Gr\148\225e: " & groesse & "x" & (groesse\2)*3
  else
    setText.text = "KEINE SETS GEFUNDEN"
  end if
  if anzRuecken > 0 and rueckenZaehler < 0 then rueckenZaehler = 0
  rueckenText.text = !"R\129cken: " & mid(ruecken(rueckenZaehler), 3)
  tischfarbe.text = "Tischfarbe: " & hex(spielerTischfarbe)
  cls
  draw string (300, 30), "E I N S T E L L U N G E N"
  draw string (50, 100), "verwendetes Kartenset:"
  setMinus.zeichnen
  setText.zeichnen
  setPlus.zeichnen
  groesseMinus.zeichnen
  groesseText.zeichnen
  groessePlus.zeichnen
  rueckenMinus.zeichnen
  rueckenText.zeichnen
  rueckenPlus.zeichnen
  if SpielerRueckenVar = 0 then
    rueckenVar.Text = !"beide R\129ckseiten"
  else
    rueckenVar.Text = !"nur R\129ckseite " & SpielerRueckenVar
  end if
  if bildR2(rueckenZaehler) = 0 then rueckenVar.zeichnen 3 else rueckenVar.zeichnen 0
  draw string (50, 302), "Soundeffekte:"
  if SpielerSound then soundEinAus.Text = "Ein" else soundEinAus.text = "Aus"
  soundEinAus.zeichnen
  draw string (50, 342), "Animation:"
  if SpielerAnimation then animation.Text = "Ein" else animation.text = "Aus"
  animation.zeichnen
  tischfarbe.zeichnen
  infosOk.zeichnen
  line (460, 80)-step(305, 215), SpielerTischfarbe, bf
  line (462, 82)-step(301, 211), BGC, b
  if setZaehler >= 0 then
    groesse = val(left(kartensets(setZaehler), 2))
    put (480, 100), bild(setZaehler), trans
    put (480 + groesse\4, 100 + groesse\4), bild(setZaehler), trans
    tischZeichnen SpielerTischfarbe, bild(setZaehler), bildR(rueckenZaehler), bildR2(rueckenZaehler), _
                  groesse, spielerRueckenVar
  end if
  do
    getmouse mx, my,, mb
    sleep 1
  loop until mb = 0
  do
    do
      getmouse mx, my,, mb
      taste = inkey
      sleep 1
    loop until mb = 1 or taste <> ""
    if taste = chr(27) or taste = chr(255, 107) or (mb = 1 and infosOk.in(mx, my)) then exit do
    if mb = 1 then
      if anzSets > 0 then
        if setMinus.in(mx, my) then
          do
            setZaehler = iif(setZaehler = 0, anzSets-1, setZaehler-1)
          loop until val(left(kartensets(setZaehler), 2)) = groesse
          setText.text = mid(kartensets(setZaehler), 3)
          setText.zeichnen
          tischZeichnen SpielerTischfarbe, bild(setZaehler), bildR(rueckenZaehler), bildR2(rueckenZaehler), _
                        groesse, spielerRueckenVar
          sleep 200
        end if
        if setPlus.in(mx, my) then
          do
            setZaehler = iif(setZaehler = anzSets-1, 0, setZaehler+1)
          loop until val(left(kartensets(setZaehler), 2)) = groesse
          setText.text = mid(kartensets(setZaehler), 3)
          setText.zeichnen
          tischZeichnen SpielerTischfarbe, bild(setZaehler), bildR(rueckenZaehler), bildR2(rueckenZaehler), _
                        groesse, spielerRueckenVar
          sleep 200
        end if
        if groesseMinus.in(mx, my) and groesse > 40 then
          tempstring = mid(kartensets(setZaehler), 3)
          dim as integer groesseNeu = groesse, setNeu, rueckenNeu
          do
            groesseNeu -= 8
            setNeu = -1
            for i as integer = 0 to anzSets-1
              if kartensets(i) = groesseNeu & tempstring then
                setNeu = i
                exit for
              end if
            next
            if setNeu < 0 then continue do
            rueckenNeu = sucheBild(ruecken(), rueckenZaehler, groesseNeu)
            if rueckenNeu >= 0 then
              groesse = groesseNeu
              setZaehler = setNeu
              rueckenZaehler = rueckenNeu
            end if
          loop until rueckenNeu > 0 or groesseNeu <= 40
          groesseText.text = !"Gr\148\225e: " & groesse & "x" & (groesse\2)*3
          groesseText.zeichnen
          if bildR2(rueckenZaehler) = 0 then rueckenVar.zeichnen 3 else rueckenVar.zeichnen 0
          tischZeichnen SpielerTischfarbe, bild(setZaehler), bildR(rueckenZaehler), bildR2(rueckenZaehler), _
                        groesse, spielerRueckenVar
          sleep 200
        end if
        if groessePlus.in(mx, my) and groesse < 96 then
          tempstring = mid(kartensets(setZaehler), 3)
          dim as integer groesseNeu = groesse, setNeu, rueckenNeu
          do
            groesseNeu += 8
            setNeu = -1
            for i as integer = 0 to anzSets-1
              if kartensets(i) = groesseNeu & tempstring then
                setNeu = i
                exit for
              end if
            next
            if setNeu < 0 then continue do
            rueckenNeu = sucheBild(ruecken(), rueckenZaehler, groesseNeu)
            if rueckenNeu >= 0 then
              groesse = groesseNeu
              setZaehler = setNeu
              rueckenZaehler = rueckenNeu
            end if
          loop until rueckenNeu > 0 or groesseNeu >= 96
          groesseText.text = !"Gr\148\225e: " & groesse & "x" & (groesse\2)*3
          groesseText.zeichnen
          if bildR2(rueckenZaehler) = 0 then rueckenVar.zeichnen 3 else rueckenVar.zeichnen 0
          tischZeichnen SpielerTischfarbe, bild(setZaehler), bildR(rueckenZaehler), bildR2(rueckenZaehler), _
                        groesse, spielerRueckenVar
          sleep 200
        end if
      end if
      if rueckenMinus.in(mx, my) then
        dim as integer i = rueckenZaehler
        do
          i -= 1
          if i < 0 then i = anzRuecken - 1
          if val(left(ruecken(i), 2)) = groesse then exit do
        loop until i = rueckenZaehler
        rueckenZaehler = i
        line (650, 100)-step(100, 150), SpielerTischfarbe, bf
        rueckenText.text = !"R\129cken: " & mid(ruecken(rueckenZaehler), 3)
        rueckenText.zeichnen
        if bildR2(rueckenZaehler) = 0 then rueckenVar.zeichnen 3 else rueckenVar.zeichnen 0
        tischZeichnen SpielerTischfarbe, bild(setZaehler), bildR(rueckenZaehler), bildR2(rueckenZaehler), _
                      groesse, spielerRueckenVar
        sleep 200
      end if
      if rueckenPlus.in(mx, my) then
        dim as integer i = rueckenZaehler
        do
          i += 1
          if i = anzRuecken then i = 0
          if val(left(ruecken(i), 2)) = groesse then exit do
        loop until i = rueckenZaehler
        rueckenZaehler = i
        line (650, 100)-step(100, 150), SpielerTischfarbe, bf
        rueckenText.text = !"R\129cken: " & mid(ruecken(rueckenZaehler), 3)
        rueckenText.zeichnen
        if bildR2(rueckenZaehler) = 0 then rueckenVar.zeichnen 3 else rueckenVar.zeichnen 0
        tischZeichnen SpielerTischfarbe, bild(setZaehler), bildR(rueckenZaehler), bildR2(rueckenZaehler), _
                      groesse, spielerRueckenVar
        sleep 200
      end if
      if rueckenVar.in(mx, my) and bildR2(rueckenZaehler) > 0 then
        spielerRueckenVar = (spielerRueckenVar + 1) mod 3
        if SpielerRueckenVar = 0 then
          rueckenVar.Text = !"beide R\129ckseiten"
        else
          rueckenVar.Text = !"nur R\129ckseite " & SpielerRueckenVar
        end if
        rueckenVar.zeichnen 0
        tischZeichnen SpielerTischfarbe, bild(setZaehler), bildR(rueckenZaehler), bildR2(rueckenZaehler), _
                      groesse, spielerRueckenVar
        do
          getmouse mx, my,, mb
          sleep 1
        loop until mb = 0
      end if
      if soundEinAus.in(mx, my) then
        SpielerSound = -1 - SpielerSound
        if SpielerSound then soundEinAus.text = "Ein" else soundEinAus.text = "Aus"
        soundEinAus.zeichnen
        do
          getmouse mx, my,, mb
          sleep 1
        loop until mb = 0
      end if
      if animation.in(mx, my) then
        SpielerAnimation = -1 - SpielerAnimation
        if SpielerAnimation then animation.text = "Ein" else animation.text = "Aus"
        animation.zeichnen
        do
          getmouse mx, my,, mb
          sleep 1
        loop until mb = 0
      end if
      if tischfarbe.in(mx, my) then
        dim as string farbe
        do
          getmouse mx, my,, mb
          sleep 1
        loop until mb = 0
        farbe = eingabe(tischfarbe.x + 135, tischfarbe.y + 4, 1)
        if farbe <> "" then
          tischfarbe.text = "Tischfarbe: " & farbe
          SpielerTischfarbe = val("&h" & farbe)
        end if
        tischfarbe.zeichnen
        line (460, 80)-step(305, 215), SpielerTischfarbe, bf
        line (462, 82)-step(301, 211), BGC, b
        put (480, 100), bild(setZaehler), trans
        put (480 + groesse\4, 100 + groesse\4), bild(setZaehler), trans
        tischZeichnen SpielerTischfarbe, bild(setZaehler), bildR(rueckenZaehler), bildR2(rueckenZaehler), _
                      groesse, spielerRueckenVar
      end if
    end if
  loop
  for i as integer = 0 to anzSets - 1
    imagedestroy bild(i)
  next
  for i as integer = 0 to anzRuecken -1
    imagedestroy bildR(i)
    if bildR2(i) <> 0 then imagedestroy bildR2(i)
  next
  ' Einstellungen speichern
  if setZaehler >= 0 then
    open "benutzer" & slash & benutzer & slash & "einstellung" for output as #f
    print #1, kartensets(setZaehler)
    print #1, ruecken(rueckenZaehler) & " " & spielerRueckenVar
    print #1, SpielerSound
    print #1, SpielerAnimation
    print #1, "&h" & hex(SpielerTischfarbe)
    close #f
  end if
  return 27*(taste = chr(255, 107))
end function

function info(pat as TypPatience) as integer
  dim as any ptr speicher = imagecreate(800, 560)
  dim as integer x, y, ystat, quer, farbe, mx, my, mb, regelanz = pat.regelanz, PV = (PATWORKVERSION and &hfffff)
  dim as TypXML xmltemp
  dim as string regelstring = "", taste, spielinhalt, punkteschnitt
  get (0, 0)-(799, 559), speicher
  windowtitle "Patfinder - " & pat.fenstername
  dim spiel as TypSpiel, f as integer = freefile
  with pat
    ' Spielinformationen laden
    if menu = 2 then
      dim as string httpinfo = httpGet("programmierung.eulengesang.de","patfinder/spiele/" & .url & ".xml")
      dim as integer such = instr(httpinfo, "<?xml ")
      xmltemp = xmlParse(mid(httpinfo, such))
      .regelaktiv = 1
      regelanz = 0
    else
      open datapfad & "spiele" & slash & .url & ".xml" for input as #f
      xmltemp = xmlParse(, f)
      close #f
      regelstring = "Regel: " & left(pat.regel(pat.regelaktiv) & space(83), 83)
    end if
    do while xmltemp.tag <> "spiel"
      if xmltemp.rest = "" then exit do
      xmltemp = xmlParse(xmltemp.rest, f)
      if inkey = chr(27) then exit do
    loop
    dim as string tempstring = xmltemp.GetAttr("fenster")
    spiel.maxX = val(left(tempstring, instr(tempstring, "x")-1))
    spiel.maxY = val(mid(tempstring, instr(tempstring, "x")+1))
    spiel.maxX = iif(spiel.maxX < 16, 32, iif(spiel.maxX > 100, 100, spiel.maxX))
    spiel.maxY = iif(spiel.maxY < 10, 20, iif(spiel.maxY > 70, 70, spiel.maxY))
    spielinhalt = xmltemp.inhalt
  end with
  do
    ' Spielfeld anzeigen
    redim as TypFeld vorlage(20)
    dim as integer anzVorlagen = 0
    spiel.felder = 0
    spielParse pat, spiel, spielinhalt, vorlage(), anzVorlagen
    screenset 1, 0
    cls
    with spiel
      line (20, 15)-step(.maxX*5 + 10, .maxY*5 + 20),, b
      for i as integer = .felder to 1 step -1
        x = .feld(i).x
        y = .feld(i).y
        if .feld(i).spezial and SQuer then quer = 1 else quer = 0
        dim as integer anz = iif(.feld(i).karten > .feld(i).kartenmax, .feld(i).kartenmax, .feld(i).karten)
        for k as integer = 0 to anz - 1
          if .feld(i).sichtbar <= k then exit for
          if x >= 0 then
            line (x*5 + quer*2 + 20, y*5 + (1-quer)*2 + 15)-step(10 + quer*5, 15 - quer*5),, b
            line (x*5 + quer*2 + 21, y*5 + (1-quer)*2 + 16)-step(8 + quer*5, 13 - quer*5), _
                 iif(.feld(i).karte(k) = 1, &h999999, BGC), bf
          end if
          if k < anz - 1 then
            if .feld(i).eng > 0 andalso .feld(i).karten >= .feld(i).eng then
              richtungsadd .feld(i).richtung, x, y, -1, 1, -1, 1
            else
              richtungsadd .feld(i).richtung, x, y, -2, 2, -2, 2
            end if
          end if
        next
        if x >= 0 and y >= 0 and .feld(i).sichtbar >= 0 then
          draw string (x*5 + quer*5 + 22, y*5 - quer*5 + 18), chr(.feld(i).kuerzel)
        end if
      next
      y = spiel.maxY*5 + 50
    end with
    if y < 280 then y = 280
    with pat
      ' Warnung bei veralteter patwork-Version
      if .programmversion > PV then
        draw string (20, y-20), !"WARNUNG: Sie ben\148tigen f\129r diese Patience eine neuere patwork-Version!", CROT
      end if
      ' Anleitung
      dim as string anleitung = .anleitung & "\n"
      dim as integer suche
      do while anleitung <> ""
        x = 20
        suche = instr(anleitung, "\n")
        if suche = 0 or suche > 95 then suche = - instrrev(anleitung, " ", 95)
        if suche = 0 then suche = len(anleitung)
        tempstring = left(anleitung, abs(suche)-1)
        draw string (x, y), tempstring
        if suche > 0 then
          anleitung = mid(anleitung, suche+2)
        else
          anleitung = mid(anleitung, -suche+1)
        end if
        y += 17
      loop
      ystat = y + 20
      if menu = 2 then
        if .inaktiv = -1 then
          draw string (20, y+20), "Diese Patience ist zur Zeit nicht installiert."
        else
          draw string (20, y+20), !"Die Patience kann aktualisiert werden."
        end if
      else
        y = ystat
        punkteschnitt = "0"
        line (20, y)-step(770, 36), BGC, bf
        line (597, 40)-step(200, 200), BGC, bf
        draw string (20, y), "Sie haben die Patience bisher " & (.gewonnen(.regelaktiv) + .verloren(.regelaktiv)) & _
                    " mal gespielt und dabei " & .gewonnen(.regelaktiv) & " mal gewonnen und " & _
                    .verloren(.regelaktiv) & " mal verloren."
        if .punktsumme(.regelaktiv) > 0 then punkteschnitt = _
                      format(.punktsumme(.regelaktiv) / (.gewonnen(.regelaktiv) + .verloren(.regelaktiv)), "###0.#")
        if right(punkteschnitt, 1) = "." or right(punkteschnitt, 1) = "," then
          punkteschnitt = left(punkteschnitt, len(punkteschnitt)-1)
        end if
        dim as string tempstring = "Im Durchschnitt erzielten Sie " & punkteschnitt & " Punkte"
        if .schnitt > 0 then tempstring &= !", der Gesamtschnitt betr\132gt " & .schnitt & " Punkte"
        draw string (20, y+20), tempstring & "."
        y += 60
        if regelanz > 1 then
          regelwahl = type<TypButton>(20, y-2, 20, 20, BRand, "")
          regeltext = type<TypButton>(50, y, 720, 0, 0, regelstring)
          regelwahl.zeichnen
          regeltext.zeichnen
        end if
        infoStatistik pat, punkteschnitt
      end if
      if pat.programmversion <= PV and pat.inaktiv = 0 then helpSpielen.zeichnen
      helpEnde.zeichnen
      screencopy 1, 0
      screenset 0, 0
      do
        getmouse mx, my,, mb
        sleep 1
      loop until mb = 0
      do
        taste = inkey
        if taste = chr(255, 107) then return -27
        getmouse mx, my,, mb
        if mb = 1 then
          if regelanz > 0 andalso regelwahl.in(mx, my) then
            .regelaktiv += 1
            if .regelaktiv > regelanz then .regelaktiv = 1
            regelstring = "Regel: " & left(.regel(.regelaktiv) & space(83), 83)
            exit do
          end if
          if  pat.programmversion <= PV and pat.inaktiv = 0 andalso helpSpielen.in(mx, my) then
            helpSpielen.zeichnen(1)
            do
              getmouse mx, my,, mb
              sleep 1
            loop until mb = 0
            helpSpielen.zeichnen
            if helpSpielen.in(mx, my) then
              spielStarten pat
              infoStatistik pat, punkteschnitt
            end if
          end if
          if helpEnde.in(mx, my) then
            helpEnde.zeichnen(1)
            do
              getmouse mx, my,, mb
              sleep 1
            loop until mb = 0
            helpEnde.zeichnen
            if helpEnde.in(mx, my) then exit do, do
          end if
          do
            getmouse mx, my,, mb
            sleep 1
          loop until mb = 0
          sleep 1
        end if
      loop until len(taste)
    end with
  loop until len(taste)
  put (0, 0), speicher, pset
  imagedestroy speicher
  windowtitle "Patfinder - Patiencen-Manager"
  return 0
end function

sub infoStatistik(pat as TypPatience, punkteschnitt as string)
  ' Statistik-Diagramm
  line (600, 20)-(800, 243), 0, bf
  with pat
    draw string (600, 20), "Die letzten 25 Spiele"
    line (625, 50)-step(5, -5)
    line step(0, 0)-step(5, 5)
    line step(-5, -5)-step(0, 115)
    line step(-2, 0)-step(137, 0)
    line step(0, 0)-step(-5, -5)
    line step(5, 5)-step(-5, 5)
    line (628, 56)-step(4, 0)
    draw string (605 + (.punktemax > 99)*8, 48), str(.punktemax)
    draw string (613, 152), "0"
    for i as integer = 5 to 25 step 5
      line (630 + 5*i, 158)-step(0, 4)
      draw string (626 + 5*i + (i > 5)*4, 170), str(i)
    next
    dim as integer schnitt25 = 0
    for i as integer = 0 to 24
      schnitt25 += .punkte(.regelaktiv, i)
    next
    if .gewonnen(.regelaktiv) + .verloren(.regelaktiv) < 25 then
      punkteschnitt = format(schnitt25 / (.gewonnen(.regelaktiv) + .verloren(.regelaktiv)), "###0.#")
    else
      punkteschnitt = format(schnitt25 / 25, "###0.#")
    end if
    if right(punkteschnitt, 1) = "." or right(punkteschnitt, 1) = "," then
      punkteschnitt = left(punkteschnitt, len(punkteschnitt)-1)
    end if
    if punkteschnitt <> "0" then line (631, 160 - val(punkteschnitt)*(104/.punktemax))-step(134, 0), 7
    ' "Welt-"Schnitt und eigener Schnitt
    if .schnitt > 0 then line (630, 160 - .schnitt*(104/.punktemax))-step(132, 0), HGRAU,, 4369
    if punkteschnitt <> "0" then
      line (630, 160 - val(punkteschnitt)*(104/.punktemax))-step(132, 0), HGRAU,, 30583
    end if
    ' Liniendiagramm
    circle (630, 160 - .punkte(.regelaktiv, 0)*(104/.punktemax)), 2,,,,, f
    for i as integer = 1 to iif(.gewonnen(.regelaktiv) + .verloren(.regelaktiv) < 25, _
                                .gewonnen(.regelaktiv) + .verloren(.regelaktiv) - 1, 24)
      line step(0, 0)-(630 + i*5, 160 - .punkte(.regelaktiv, i)*(104/.punktemax))
      circle step(0, 0), 2,,,,, f
    next
    draw string (600, 210), "Schnitt der letzten"
    draw string (600, 227), "25 Spiele: " & punkteschnitt & " Punkte"
  end with
end sub

sub quicksort(a() as string, byval s as integer = 0, byval e as integer = &hffff)
  if s = 0 then s = lbound(a)
  if e = &hffff then e = ubound(a)
  dim as integer i = s, j = e
  dim as string mitte = lcase(a((i+j)\2))
  do
    while lcase(a(i)) < mitte : i += 1 : wend
    while lcase(a(j)) > mitte : j -= 1 : wend
    if i <= j then
      swap a(i), a(j)
      i += 1
      j -= 1
    end if
  loop until i > j
  if j > s then quicksort(a(), s, j)
  if i < e then quicksort(a(), i, e)
end sub

sub quicksort(array() as TypPatience, byval start as integer = 0, byval ende as integer = &hffff)
  if start = 0 then start = lbound(array)
  if ende = &hffff then ende = ubound(array)
  dim as integer i = start, j = ende
  dim as string mitte = array((i+j)\2).sortname
  do
    while array(i).sortname < mitte : i += 1 : wend
    while array(j).sortname > mitte : j -= 1 : wend
    if i <= j then
      swap array(i), array(j)
      i += 1
      j -= 1
    end if
  loop until i > j
  if j > start then quicksort(array(), start, j)
  if i < ende then quicksort(array(), i, ende)
end sub

function sortname(text as string) as string
  dim as string ret = lcase(text)
  if left(ret, 4) = "der " or left(ret, 4) = "die " or left(ret, 4) = "das " then ret = mid(ret, 5)
  dim as string*2 uml(6, 1) = {{chr(195, 164), "ae"}, {chr(195, 182), "oe"}, {chr(195, 188), "ue"}, _
        {chr(195, 132), "ae"}, {chr(195, 150), "oe"}, {chr(195, 156), "ue"}, {chr(195, 159), "ss"}}
  dim as integer such
  for i as integer = 0 to 6
    do
      such = instr(ret, uml(i, 0))
      if such = 0 then exit do
      ret = left(ret, such-1) & uml(i, 1) & mid(ret, such+2)
    loop
  next
  return ret
end function

sub spielParse(pat as TypPatience, spiel as TypSpiel, inhalt as string, vorlage() as TypFeld, anzVorlagen as integer)
  dim xmltemp as TypXML, kuerzel as integer, xmlrest as string = inhalt
  do while xmlrest <> ""
    xmltemp = xmlParse(xmlrest)
    with xmltemp
    select case .tag
      case "regel"
        if .GetAttr("id") = pat.regelID(pat.regelAktiv) then spielParse pat, spiel, .inhalt, vorlage(), anzVorlagen
      case "punktemax" : pat.punktemax = valint(.inhalt)
      case "karten"    : spiel.kartenset = val(.inhalt): spiel.karten = spiel.kartenset
      case "add"
        if .GetAttr("typ") = "karte" and spiel.karten < 208 then spiel.karten += 1
        if .GetAttr("typ") = "familie" then
          if len(.inhalt) < 3 then
            if spiel.karten < 205 then spiel.karten += 4
          else
            if spiel.kartenset = 32 or spiel.kartenset = 64 then
              if spiel.karten < 201 then spiel.karten += 8
            else
              if spiel.karten < 196 then spiel.karten += 13
            end if
          end if
        end if
      case "sub"
        if .GetAttr("typ") = "karte" then spiel.karten -= 1
        if .GetAttr("typ") = "familie" then
          if len(.inhalt) < 3 then
            spiel.karten -= 4
          else
            if spiel.kartenset = 32 or spiel.kartenset = 64 then spiel.karten -= 8 else spiel.karten -= 13
          end if
        end if
        if spiel.karten < 0 then spiel.karten = 0
      case "vorlage", "feld"
        dim as TypFeld ptr feldptr
        if .tag = "vorlage" then
          anzVorlagen += 1
          if ubound(vorlage) < anzVorlagen then redim preserve vorlage(1 to anzVorlagen + 10)
          feldptr = @vorlage(anzVorlagen)
        else
          spiel.felder += 1
          feldptr = @spiel.feld(spiel.felder)
        end if
        feldptr->typ  = .GetAttr("typ")
        select case feldptr->typ
          case "keller"
            feldptr->kartenmax = 1
            feldptr->kuerzel = asc("k")
          case "stock", "abwurf", "grund", "hilf", "reserve"
            feldptr->kuerzel = asc(ucase(feldptr->typ))
          case else
            for i as integer = 1 to anzVorlagen
              if feldptr->typ = vorlage(i).id then
                feldptr->kartenmax = vorlage(i).kartenmax
                feldptr->richtung  = vorlage(i).richtung
                feldptr->eng       = vorlage(i).eng
                feldptr->sichtbar  = vorlage(i).sichtbar
                feldptr->verdeckt  = vorlage(i).verdeckt
                feldptr->spezial   = vorlage(i).spezial
                feldptr->karten    = vorlage(i).karten
                for k as integer = 0 to vorlage(i).karten - 1
                  feldptr->karte(k) = vorlage(i).karte(k)
                next
                feldptr->kuerzel = vorlage(i).kuerzel
                exit for
              end if
            next
        end select
        kuerzel = asc(.GetAttr("kuerzel"))
        if kuerzel > 32 and kuerzel < 128 then feldptr->kuerzel = kuerzel
        if feldptr->kuerzel < 33 or feldptr->kuerzel >127 then feldptr->kuerzel = asc("X")
        feldptr->id = .GetAttr("id")
        feldptr->x  = val(.GetAttr("x"))
        feldptr->y  = val(.GetAttr("y"))
        feldptr->sichtbar = 208
        if feldptr->x > spiel.maxX then feldptr->x = spiel.maxX
        if feldptr->y > spiel.maxY then feldptr->y = spiel.maxY
        dim feldrest as string = .inhalt, feldxml as TypXML
        do while feldrest <> ""
          feldxml = xmlParse(feldrest)
          select case feldxml.tag
            case "max"     : feldptr->kartenmax = val(feldxml.inhalt)
            case "richtung": feldptr->richtung  = sucheRichtung(feldxml.inhalt)
            case "eng"     : feldptr->eng       = val(feldxml.inhalt)
            case "sicht"   : if feldxml.inhalt  = "verdeckt" then feldptr->verdeckt = 1
            case "sichtbar"
              if feldxml.inhalt = "komplett" then
                feldptr->sichtbar = 208
              else
                feldptr->sichtbar = valint(feldxml.inhalt)
              end if
            case "lage"    : if feldxml.inhalt  = "quer" then feldptr->spezial or= SQuer
            case "lege"
              dim as integer legeanz = 1
              if feldxml.GetAttr("anz") <> "" then legeanz = val(feldxml.GetAttr("anz"))
              for i as integer = 1 to legeanz
                if feldptr->karten > 207 then exit for
                if feldxml.GetAttr("typ") = "verdeckt" then
                  feldptr->karte(feldptr->karten) = 1
                end if
                feldptr->karten += 1
              next
          end select
          feldrest = feldxml.rest
        loop
      end select
    end with
    xmlrest = xmltemp.rest
  loop
end sub

sub spielStarten(pat as TypPatience)
  dim as integer spielantwort = 1, t, zeit, f = freefile, tempint, spielergebnis, punkte
  dim as string exec_return
  do
    with pat
      ' wenn Speicherstand vorhanden, dann bisher gespielte Zeit auslesen
      if spielantwort = 1 then t = timer
      if dir(datapfad & "benutzer" & slash & benutzer & slash & .url & ".sav") <> "" then
        open datapfad & "benutzer" & slash & benutzer & slash & .url & ".sav" for binary as #f
        seek f, 1
        get #f,, zeit
        get #f,, tempint
        get #f,, .regelaktiv
        close #f
        if zeit and &h80000000 then spielantwort = 2
        t = timer - (zeit and &h7fffffff)
      end if
      ' starte gefundenes Programm
      dim as string param = .url & " -n " & benutzer & " -r " & .regelaktiv & " -z " & t
      if .levelmax > 0 then param &= " -l " & .level(.regelaktiv)
      open pipe root & "patwork " & param for input as #f
      input #f, exec_return
      spielergebnis = valint(exec_return)
      punkte = (spielergebnis and &hffff)
      close #f
      zeit = timer - t
      if spielergebnis shr 16 = 3 then
        ' Spiel wurde gespeichert
        ' wenn Wiederholungsspiel, dann dies vermerken
        if spielantwort = 2 then zeit or= &h80000000
        open root & "benutzer" & slash & benutzer & slash & .url & ".sav" for binary as #f
        seek f, 1
        put #f,, zeit
        close #f
        exit sub
      end if
      if spielantwort = 1 then
        ' Statistik berechnen ...
        if spielergebnis shr 16 = 1 then
          ' Spiel gewonnen
          .gewonnen(.regelaktiv) += 1
          .level(.regelaktiv) += 1
          if .level(.regelaktiv) > .levelmax then .level(.regelaktiv) = .levelmax
          if .zeitgewinnmin(.regelaktiv) > zeit or .zeitgewinnmin(.regelaktiv) = 0 then _
             .zeitgewinnmin(.regelaktiv) = zeit
          if .zeitgewinnmax(.regelaktiv) < zeit then .zeitgewinnmax(.regelaktiv) = zeit
          .zeitgewinnsumme(.regelaktiv) += zeit
        elseif (spielergebnis shr 16 = 2) or (spielergebnis shr 16 = 4) then
          ' Spiel verloren
          .verloren(.regelaktiv) += 1
          .level(.regelaktiv) -= 1
          if .level(.regelaktiv) < 0 then .level(.regelaktiv) = 0
          if (.zeitverliermin(.regelaktiv) > zeit or .zeitverliermin(.regelaktiv) = 0) and zeit > 0 then _
             .zeitverliermin(.regelaktiv) = zeit
          if .zeitverliermax(.regelaktiv) < zeit then .zeitverliermax(.regelaktiv) = zeit
          .zeitverliersumme(.regelaktiv) += zeit
        end if
        select case spielergebnis and &hff0000
          case 0  ' unerwarteter Fehler aufgetreten
            spielantwort = nachricht("Leider ist ein unerwarteter Fehler aufgetreten!\nBitte teilen Sie " & _
              "mir mit, in welcher Patience\nder Fehler auftrat und (möglichst genau) wie er\nzustande " & _
              "kam. Vielen Dank für Ihre Hilfe!\nKontaktadresse: programmierung@eulengesang.de", "  OK  ")
            exit do
          case 6  ' Spieldatei nicht gefunden
            spielantwort = nachricht("Leider ist ein unerwarteter Fehler aufgetreten:\nDie Spieledatei " & _
              "konnte nicht gefunden werden!\nBitte starten Sie das Programm neu, um die Liste\n" & _
              "der verfügbaren Spiele zu aktualisieren.", "  OK  ")
        end select
        if .gewonnen(.regelaktiv) + .verloren(.regelaktiv) > 25 then
          for i as integer = 0 to 23
            .punkte(.regelaktiv, i) = .punkte(.regelaktiv, i+1)
          next
          .punkte(.regelaktiv, 24) = punkte
        else
          .punkte(.regelaktiv, .gewonnen(.regelaktiv)+.verloren(.regelaktiv)-1) = punkte
        end if
        .punktsumme(.regelaktiv) += punkte
        ' ... und speichern
        open datapfad & "benutzer" & slash & benutzer & slash & .url & ".stat" for output as #f
        for r as integer = 1 to .regelanz
          print #f, .gewonnen(r) & "," & .verloren(r) & "," & .punktsumme(r);
          print #f, "," & .level(r) & ",";
          for i as integer = 0 to 24
            print #f, .punkte(r, i) & ",";
          next
          print #f, .zeitgewinnmin(r) & "," & .zeitgewinnmax(r) & ",";
          print #f, .zeitgewinnsumme(r) & "," & .zeitverliermin(r) & ",";
          print #f, .zeitverliermax(r) & "," & .zeitverliersumme(r)
        next
        if .regelanz > 1 then print #f, .regelaktiv
        close #f
      end if
      ' evtl. Spielwiederholung
      dim as string spieldauer = str(zeit \ 60) & ":" & format(zeit mod 60, "00")
      if spielergebnis shr 16 = 1 then
        spielantwort = nachricht("Herzlichen Glückwunsch, Sie haben das Spiel\nnach einer Spielzeit von " & _
          spieldauer & " gewonnen!\n \n" & "Wollen Sie noch einmal spielen?", _
          "Neues Spiel\nWiederholen\nZurück")
      elseif spielergebnis shr 16 = 4 then
        spielantwort = 1
      else
        spielantwort = nachricht("Sie haben das Spiel nach einer Spielzeit\nvon " & spieldauer & _
          " beendet und in dieser Zeit\n" & punkte & " von " & .punktemax & " Punkte erzielt.\n \n" & _
          "Wollen Sie noch einmal spielen?", "Neues Spiel\nWiederholen\nZurück")
      end if
    end with
  loop until spielantwort = 3
end sub

function sucheBild(bilderliste() as string, altesBild as integer, groesse as integer) as integer
  dim as string bildname = mid(bilderliste(altesBild), 3)
  dim as integer i = altesBild, bildNeu = -1
  do
    i += 1
    if i > ubound(bilderliste) then i = lbound(bilderliste)
    if bilderliste(i) = groesse & bildname then return i
    if val(left(bilderliste(i), 2)) = groesse then bildNeu = i
  loop until i = altesBild
  return bildNeu
end function

sub statistikEinlesen(benutzer as string, byref pat as TypPatience)
  ' Statistik einlesen (falls vorhanden)
  dim as integer f = freefile
  with pat
    if open(datapfad & "benutzer" & slash & benutzer & slash & .url & ".stat" for input as #f) = 0 then
      for r as integer = 1 to .regelanz
        input #f, .gewonnen(r), .verloren(r), .punktsumme(r), .level(r)
        for i as integer = 0 to 24
          input #f, .punkte(r, i)
        next
        input #f, .zeitgewinnmin(r), .zeitgewinnmax(r), .zeitgewinnsumme(r),.zeitverliermin(r)
        input #f, .zeitverliermax(r), .zeitverliersumme(r)
      next
      if .regelanz > 0 then input #f, .regelaktiv
      if .regelaktiv < 1 or .regelaktiv > .regelanz then .regelaktiv = 1
      close #f
    else
      open datapfad & "benutzer" & slash & benutzer & slash & .url & ".stat" for output as #f
      for r as integer = 1 to .regelanz
        for i as integer = 1 to 34
          print #f, 0 & ",";
        next
        print #f, 0
        .gewonnen(r) = 0 : .verloren(r) = 0 : .punktsumme(r) = 0 : .level(r) = 0
        for i as integer = 0 to 24
          .punkte(r, i) = 0
        next
        .zeitgewinnmin(r) = 0 : .zeitgewinnmax(r) = 0 : .zeitgewinnsumme(r) = 0 : .zeitverliermin(r) = 0:
        .zeitverliermax(r) = 0 : .zeitverliersumme(r) = 0
      next
      .regelaktiv = 1
      close #f
    end if
  end with
end sub

sub tischZeichnen(tisch as integer, vorn as any ptr, byval hinten as any ptr, byval hinten2 as any ptr, _
                  breite as integer, ruecken as integer)
  screenlock
  line (463, 83)-step(299, 209), tisch, bf
  put (480, 100), vorn, trans
  put (480 + breite\4, 100 + breite\4), vorn, trans
  if hinten2 <> 0 then
    if ruecken = 1 then
      hinten2 = hinten
    elseif ruecken = 2 then
      hinten = hinten2
    end if
  end if
  if hinten2 <> 0 then
    put (620, 100), hinten2, trans
    put (620 + breite\4, 100 + breite\4), hinten, trans
  else
    put (620, 100), hinten, trans
  end if
  screenunlock
end sub
